VERSION 5.00
Begin VB.Form frmMain 
   BorderStyle     =   0  'Kein
   Caption         =   "Form1"
   ClientHeight    =   3195
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4680
   BeginProperty Font 
      Name            =   "Arial"
      Size            =   12
      Charset         =   0
      Weight          =   700
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   KeyPreview      =   -1  'True
   LinkTopic       =   "Form1"
   ScaleHeight     =   3195
   ScaleWidth      =   4680
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows-Standard
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'Dieser Source stammt von http://www.vb-fun.de
'und kann frei verwendet werden. Fr eventuelle Schden
'wird nicht gehaftet.

'Um Fehler oder Fragen zu klren, nutzen Sie bitte unser Forum.
'Ansonsten viel Spa und Erfolg mit diesem Source-Code !

Option Explicit

'=== DirectDraw-Initialisations-Variablen ===
Dim DX7 As New DirectX7
Dim DD7 As DirectDraw7
Dim SurfaceDesc As DDSURFACEDESC2
Dim PrimarySurface As DirectDrawSurface7
Dim BackBuffer As DirectDrawSurface7
Dim bmpBild1 As DirectDrawSurface7

Dim Regensetzen As Boolean

Private Type Regen
    x As Long
    y As Long
    Geschw As Single
End Type
Dim Regen(1000) As Regen

Dim Regenlnge As Integer
Dim RegenSpeed As Integer
Dim RegenAnzahl As Integer
Dim Eigenschaft As Single

Dim running As Boolean

Private Sub Form_KeyPress(KeyAscii As Integer)
    If (KeyAscii = vbKeyEscape) Then
        running = False
    End If
End Sub

Private Sub Form_KeyUp(KeyCode As Integer, Shift As Integer)
    If (KeyCode = vbKeyUp) Then
        Eigenschaft = Eigenschaft - 1
        If Eigenschaft < 1 Then Eigenschaft = 3
    End If
    If (KeyCode = vbKeyDown) Then
        Eigenschaft = Eigenschaft + 1
        If Eigenschaft > 3 Then Eigenschaft = 1
    End If
    If (KeyCode = vbKeyLeft) Then
        Select Case Eigenschaft
            Case 1: RegenSpeed = RegenSpeed - 1
                    If RegenSpeed < 1 Then RegenSpeed = 1
            Case 2: Regenlnge = Regenlnge - 1
                    If Regenlnge < 1 Then Regenlnge = 1
            Case 3: RegenAnzahl = RegenAnzahl - 10
                    If RegenAnzahl < 10 Then RegenAnzahl = 10
        End Select
    End If
    If (KeyCode = vbKeyRight) Then
        Select Case Eigenschaft
            Case 1: RegenSpeed = RegenSpeed + 1
                    If RegenSpeed > 30 Then RegenSpeed = 30
            Case 2: Regenlnge = Regenlnge + 1
                    If Regenlnge > 30 Then Regenlnge = 30
            Case 3: RegenAnzahl = RegenAnzahl + 10
                    If RegenAnzahl > 200 Then RegenAnzahl = 200
        End Select
    End If
End Sub

Private Sub Form_Load()
    Dim srcrect As RECT
    
    Me.Show
    Me.Refresh
    Regenlnge = 20
    RegenSpeed = 10
    RegenAnzahl = 100
    Eigenschaft = 1
    
    Initialization   'DirectDraw initialisieren
    BitmapLaden      'Laden der Bitmaps
    
    running = True
    
    Do
        
        'Hintergrundbild zeichnen
        With srcrect
            .Left = 0: .Right = 800
            .Top = 0: .Bottom = 600
        End With
        BackBuffer.BltFast 0, 0, bmpBild1, srcrect, DDBLTFAST_WAIT
        
        'Regen zeichnen
        Regnen RegenAnzahl, RegenSpeed
        
        BackBuffer.SetForeColor vbRed
        BackBuffer.SetFont Me.Font
        BackBuffer.DrawText 10, 20, "Auswahl der Eigenschaft mit Cursortaste rauf/runter", False
        BackBuffer.DrawText 10, 40, "Verndern des Wertes mit Cursortaste links/rechts", False
        If Eigenschaft = 1 Then BackBuffer.SetForeColor vbGreen
        BackBuffer.DrawText 10, 60, "Geschwindigkeit: " & RegenSpeed, False
        BackBuffer.SetForeColor vbRed
        If Eigenschaft = 2 Then BackBuffer.SetForeColor vbGreen
        BackBuffer.DrawText 10, 80, "Regenlnge: " & Regenlnge, False
        BackBuffer.SetForeColor vbRed
        If Eigenschaft = 3 Then BackBuffer.SetForeColor vbGreen
        BackBuffer.DrawText 10, 100, "Tropfenanzahl: " & RegenAnzahl, False
        BackBuffer.SetForeColor vbWhite
        
        'Inhalt des BackBuffers in den PrimarySurface kopieren
        PrimarySurface.Flip Nothing, DDFLIP_WAIT
        
        'BackBuffer lschen
        'da ansonsten alter Speicherinhalt angezeigt wird
        ClearBuffer 0
        
        DoEvents
    Loop While running
    
    Terminate
    
End Sub

Function Regnen(Anzahl As Integer, Geschwindigkeit As Integer)
    Dim x As Integer
    Dim y As Integer
    Dim z As Integer
    Dim I As Integer
    Dim x2 As Long

    If Regensetzen = False Then
        Randomize
        For I = 0 To Anzahl
            x = Rnd * 800
            y = Rnd * 600
            z = Rnd * Geschwindigkeit
            
            Regen(I).x = x
            Regen(I).y = y
            Regen(I).Geschw = z + Geschwindigkeit
            BackBuffer.SetForeColor vbWhite
            BackBuffer.DrawLine Regen(I).x, Regen(I).y, Regen(I).x, Regen(I).y + Regenlnge
        Next I
        Regensetzen = True
    End If

    For I = 0 To Anzahl
        Regen(I).y = Regen(I).y + Regen(I).Geschw
        BackBuffer.DrawLine Regen(I).x, Regen(I).y, Regen(I).x, Regen(I).y + Regenlnge
        If Regen(I).y > 600 Then
            x = Rnd * 800
            y = Rnd * 600
            z = Rnd * Geschwindigkeit
        
            Regen(I).x = x
            Regen(I).y = 0
            Regen(I).Geschw = z + Geschwindigkeit
            BackBuffer.DrawLine Regen(I).x, Regen(I).y, Regen(I).x, Regen(I).y + Regenlnge
        End If
    Next I
End Function

Sub Initialization()
    
    'Holen wir uns den Zugriff auf das DirectDraw-Objekt.
    'Der leere String-Parameter bedeutet,
    'dass der aktive Bildschirmtreiber benutzt werden soll
    Set DD7 = DX7.DirectDrawCreate("")
    'Die Anwendung soll im VollbildModus laufen
    DD7.SetCooperativeLevel Me.hWnd, DDSCL_EXCLUSIVE Or DDSCL_FULLSCREEN Or DDSCL_ALLOWREBOOT
    'Auflsung und Farbtiefe deklarieren
    DD7.SetDisplayMode 800, 600, 16, 0, DDSDM_DEFAULT
    'Beschreibung des PrimarySurface mit einem BackBuffer
    With SurfaceDesc
        .lFlags = DDSD_CAPS Or DDSD_BACKBUFFERCOUNT
        .ddsCaps.lCaps = DDSCAPS_PRIMARYSURFACE Or DDSCAPS_FLIP Or DDSCAPS_COMPLEX
        .lBackBufferCount = 1
    End With
    'PrimarySurface initialisieren auf dem alles abgebildet wird
    Set PrimarySurface = DD7.CreateSurface(SurfaceDesc)
    
    'Fr die Beschreibung des Backbuffers bentigen wir nur
    'den ddsCaps-Bereich
    SurfaceDesc.ddsCaps.lCaps = DDSCAPS_BACKBUFFER
    'BackBuffer initialisieren in dem alles gezeichnet und dann
    'in die PrimarySurface ge'flipt wird
    Set BackBuffer = PrimarySurface.GetAttachedSurface(SurfaceDesc.ddsCaps)

End Sub

Sub BitmapLaden()
    Dim BmpDesc As DDSURFACEDESC2
        
    BmpDesc.lFlags = DDSD_CAPS Or DDSD_HEIGHT Or DDSD_WIDTH
    BmpDesc.ddsCaps.lCaps = DDSCAPS_OFFSCREENPLAIN
    
    BmpDesc.lWidth = 800
    BmpDesc.lHeight = 600
    
    Set bmpBild1 = DD7.CreateSurfaceFromFile(App.Path & "\Foto.bmp", BmpDesc)
    
End Sub

Sub Terminate()

    Set bmpBild1 = Nothing
    'alte Auflsung wiederherstellen
    DD7.RestoreDisplayMode
    DD7.SetCooperativeLevel Me.hWnd, DDSCL_NORMAL
    Set PrimarySurface = Nothing
    Set DD7 = Nothing
    Set DX7 = Nothing
    End

End Sub

Sub ClearBuffer(Color As Long)
    Dim destrect As RECT
    With destrect
        .Bottom = 600
        .Left = 0
        .Right = 800
        .Top = 0
    End With
    BackBuffer.BltColorFill destrect, Color
End Sub


